; This is a minimum test-proggy..........
; Reading 1 sector from a CDROM
; Communicating with SCSI and ATAPI CD-ROM devices via SPTI
; by: Siekmanski.

; Works on Windows 2000 Windows XP Windows Server 2003
; For Windows 95/98 SE and Windows ME we need ASPI
; I'll do that soon..... see you have fun. 

; You can find all info about "SCSI-3 Multimedia Commands (MMC)" at http://www.t10.org/drafts.htm

.486
.model FLAT,STDCALL
option casemap:none

include \masm32\include\windows.inc
include \masm32\include\user32.inc
include \masm32\include\kernel32.inc
include \masm32\include\masm32.inc

includelib \masm32\lib\user32.lib
includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\masm32.lib

TEXT_ MACRO your_text:VARARG
	LOCAL text_string
	.data
	 text_string db your_text,0
	.code
	EXITM <addr text_string>
ENDM


IOCTL_SCSI_PASS_THROUGH_DIRECT equ 04d014h

SCSI_IOCTL_DATA_OUT            equ 0 ;Write
SCSI_IOCTL_DATA_IN             equ 1 ;Read
SCSI_IOCTL_DATA_UNSPECIFIED    equ 2 ;eject etc.


_SCSI_PASS_THROUGH_DIRECT struct
    _Length		dw ?	;0
    ScsiStatus		db ?	;2
    PathId			db ?	;3
    TargetId		db ?	;4
    Lun			db ?	;5
    CdbLength		db ?	;6
    SenseInfoLength		db ?	;7
    DataIn			db ?	;8
			db 3 dup (?) ; align ????? Without it didn't work
    DataTransferLength	dd ?	;12
    TimeOutValue		dd ?	;16
    DataBuffer		dd ?	;20
    SenseInfoOffset		dd ?	;24
    Cdb			db 16 dup (?) ;28
_SCSI_PASS_THROUGH_DIRECT ends

SCSI_PASS_THROUGH_DIRECT typedef _SCSI_PASS_THROUGH_DIRECT

.data

szHallo 	db "Siekmanski's SPTI CD-reader test 2006",13,10,13,10,0


DriveString	db "\\.\"
DriveLetter	db " :",0

LBA_sector	dd 150	; sector to read
 
.data?

szString_buffer	db 128 dup (?)

CDrom_count	dd ?
CD_ROMS	dd 26 dup (?)
CD_ROMnum	dd ?
hCDrom		dd ?

SCSI_DataBuffer db 2352+96 dup (?)

sptd	SCSI_PASS_THROUGH_DIRECT <?>

.code


Find_cdroms proc
local Drive:dword
	pushad
	lea	edi,CD_ROMS
	lea	ebx,Drive
	mov 	CDrom_count,0
	mov	dword ptr [ebx],05C3A43h   ; "C:\",0
	.while	byte ptr [ebx] <= "Z"
		invoke GetDriveType,ebx
		.if	eax == DRIVE_CDROM
			mov	eax,[ebx]
			mov	[edi],eax
			inc	CDrom_count
			add	edi,4
		.endif
		inc byte ptr [ebx]
	.endw
	popad
	ret
Find_cdroms endp


CloseCDrom proc
	.if	(hCDrom != NULL)
		invoke	CloseHandle,hCDrom
		mov	hCDrom,NULL
		invoke	StdOut,TEXT_("Cdrom closed...",13,10)
	.endif
	ret
CloseCDrom endp

OpenCDrom proc
local dwAccessMode:dword
	mov	hCDrom,NULL
	mov	dwAccessMode,GENERIC_READ or GENERIC_WRITE
	invoke	CreateFile,addr DriveString,dwAccessMode,FILE_SHARE_READ or FILE_SHARE_WRITE,NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL
	mov	hCDrom,eax
	.if	eax == INVALID_HANDLE_VALUE
		mov	dwAccessMode,GENERIC_READ
		invoke	CreateFile,addr DriveString,dwAccessMode,FILE_SHARE_READ or FILE_SHARE_WRITE,NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL
		mov	hCDrom,eax
			.if	eax == INVALID_HANDLE_VALUE
				mov	hCDrom,NULL
				invoke	StdOut,TEXT_("Cannot open Cdrom !",13,10,13,10)
			.endif
	.endif

	invoke	wsprintf,addr szString_buffer,TEXT_("Open CD-Rom %s ...",13,10,13,10),addr DriveLetter
	invoke	StdOut,addr szString_buffer
	ret    
OpenCDrom endp


SendSCSIcommand proc
local dwBytesReturned:dword

	invoke	DeviceIoControl,hCDrom,IOCTL_SCSI_PASS_THROUGH_DIRECT,addr sptd,sizeof sptd,addr sptd,sizeof sptd,addr dwBytesReturned,NULL
 
   	.if (eax)
		mov	eax,TRUE
		ret
	.else
		invoke	GetLastError
		invoke	wsprintf,addr szString_buffer,TEXT_("Errorcode: %d",13,10,13,10),eax
		invoke	StdOut,addr szString_buffer
	.endif
	mov	eax,FALSE
	ret
SendSCSIcommand endp



ReadSector proc Sector:DWORD
	push	edi
	lea	edi,sptd
	xor	eax,eax
	mov	ecx,sizeof sptd
	cld
	rep	stosb
	pop	edi

	mov	sptd._Length,sizeof sptd
	mov	sptd.CdbLength,12
	mov	sptd.DataIn,SCSI_IOCTL_DATA_IN
	mov	sptd.DataTransferLength,2352
	mov	sptd.TimeOutValue,108000
	mov	sptd.DataBuffer,offset SCSI_DataBuffer

	lea	eax,sptd.Cdb
	mov	byte ptr [eax+0],0beh 	; read cd
	mov	byte ptr [eax+1],0 	; all types "cd-da mode 1 2 etc."

	mov	ecx,Sector
	bswap	ecx
	mov	dword ptr [eax+2],ecx 

	mov	byte ptr [eax+8],1	; 1 logical block
        	mov    	byte ptr [eax+9],11111000b	;read 2352 bytes
                                ;.......| reserved
                                ;.....||  no errors returned  
                                ;....|    edc-ecc
                                ;...|     user data
                                ;.||      all headers
                                ;|        sync
	mov	byte ptr [eax+10],0	; No sub-channel data

	invoke	SendSCSIcommand
	ret
ReadSector endp



start:
	invoke	StdOut,addr szHallo

	invoke	Find_cdroms
	mov	eax,CDrom_count
	invoke	wsprintf,addr szString_buffer,TEXT_("CD-Roms found: %d",13,10,13,10),eax
	invoke	StdOut,addr szString_buffer

	lea 	esi,CD_ROMS
	mov	CD_ROMnum,0	;eerste cd-rom
	mov	eax,CD_ROMnum
	mov	al,byte ptr [esi+eax*4]
	mov	DriveLetter,al
	invoke	OpenCDrom

	invoke	ReadSector,LBA_sector

   	.if (eax)
		invoke	StdOut,TEXT_("SendSCSIcommand OK !",13,10)
		lea	eax,SCSI_DataBuffer
		mov	eax,[eax]
		invoke	wsprintf,addr szString_buffer,TEXT_("First DWORD read from LBA_sector: %d = %xH",13,10,13,10),LBA_sector,eax
		invoke	StdOut,addr szString_buffer
	.endif


	invoke	CloseCDrom
	invoke	Sleep,4000

	invoke	ExitProcess,0
end start